//obsluha zalozky Settings

procedure SetOnChange(sender:TObject);
begin
  GGForm_butSave.Enabled:=true;
  if(sender=GGForm_lProfiles) then
    sProfile:=GGForm_lProfiles.Items[GGForm_lProfiles.ItemIndex];
end;

procedure butGcCzIdOnClick(sender:TObject);
var s:string;
begin
  if(GGForm_eNickCz.Text='') then exit;
  if(sender<>nil) then GGForm_butGcCzId.Cursor:=crHourglass;
  if(HttpAsk('GET','http://www.geocaching.cz/api.php?a=username2id&v=1&d='+EncodeURLelement(AnsiToUtf(GGForm_eNickCz.Text)),'','',s))then begin
    s:=ReplaceString(UtfToAnsi(s),CRLF,'--');
    //vybereme jen cislice za nickem a strednikem
    s:=RegexSubstitute('(?si)'+EncodeRegElement(GGForm_eNickCz.Text)+';([0-9]*)',s,'$1');
  end;
  GGForm_eIdcz.Text:=s;
  if(sender<>nil) then GGForm_butGcCzId.Cursor:=crDefault;
  SetOnChange(nil);
end;

procedure butGuidComOnClick(sender:TObject);
begin
	//Call OLD API
  //SetOnChange(nil);
end;

procedure SendImg(bHourglass:boolean);
var i:integer;
    sPath:string;
begin
  //pouzit standardni banner na gc.cz, vlastni obrazek nebo nahled na statistiku
  //(rovnez ulozenou na gc.cz)?
  i:=MessBox(_('For URL you can use banner, preview or own picture.')      
    +' '+_('For default banner, you don''t need to save it to server.')+CRLF+CRLF                
    +_('Send picture with preview? Choose:')+CRLF+CRLF   
    +_('Yes ... create and save preview to server')+CRLF 
    +_('No ... send your own picture')+CRLF                          
    +_('Cancel ... interrupt proccessing'),                             
  _('Choose picture for statistics URL'),3);                       
  {$ifdef DEBUG_HELPER} LDH('Pouzita volba i='+IntToStr(i));{$endif}
  if(i=2) then exit      //cacnel
  else if(i=6) then sPath:='' //Ano, nahled
  else if(i=7) then begin      //Ne, nechame si najit obrazek
    if(not OpenDlg(_('Select file'),                //title
                 GEOGET_DATADIR,                //InitDir
                'ofFileMustExist,ofHideReadOnly,ofNoChangeDir', //options
                _('PNG pictures')+' (*.png)|*.png'   //filtr pripon
                    +'|'+_('JPG pictures')+' (*.jpg)|*.jpg'
                ,sPath)) then exit;
    {$ifdef DEBUG_HELPER} LDH('Vybrany obrazek: '+sPath);{$endif}
  end
  else exit;
  if(bHourglass) then GGForm_butSendImage.Cursor:=crHourglass;  //kurzor
  SendPreviewImgToGcCz(sPath,GGForm_eNickCz.Text,GGForm_ePwdCz.Text,GGForm_eIdCz.Text);
  if(bHourglass) then GGForm_butSendImage.Cursor:=crDefault;  //kurzor
end;

procedure SendHtml(bHourglass:boolean);
var sFileSrc:string;
    b:boolean;
begin
  {$ifdef DEBUG_HELPER} LDH('Odeslani HTML (0) statistiky nebo CSS (1) na gc.cz, cil='+IntToStr(GGForm_lTarget.ItemIndex));{$endif}
  if(GGForm_eSetFileOut.Text='') then GGForm_eSetFileOut.Text:='Statistics.html';
  sFileSrc:=RelToAbsFilename(GGForm_eSetFileOut.Text,GetProfileDir());
  if(not FileExists(sFileSrc)) then begin
    ShowMessage(_('File not found')+': '+CRLF+sFileSrc);
    exit;
  end;
  {$ifdef DEBUG_HELPER} LDH('Odesilany soubor: '+sFileSrc);{$endif}
  //odesilame soubor podle toho, kam se ma odeslat
  if(bHourglass) then GGForm_butSendHtml.Cursor:=crHourglass;  //kurzor
  case GGForm_lTarget.ItemIndex of
  0: begin //odeslat na gc.cz
       b:=SendFileToGcCz(sFileSrc, GGForm_eNickCz.Text,GGForm_ePwdCz.Text,GGForm_eIdCz.Text);
     end;
  1: begin //odeslat na vlastni FTP
       b:=SendFileToFtp(sFileSrc, GGForm_eFtpUser.Text,GGForm_eFtpPwd.Text,GGForm_eFtpUrl.Text,GGForm_eFtpBrowserUrl.Text);
     end;
  2:; //neodesilat
  end;
  if(bHourglass) then GGForm_butSendHtml.Cursor:=crDefault;  //kurzor
end;

procedure SendLink(sImg:string);
var sHtml,sLanguage,sUrl:string;
begin  //vytvori HTML s odkazem na statistiku, vlozi to do schranky, otevre browser
       //s profilem na gc.com, aby se tam dal odkaz vlozit
  if(sImg='banner') then begin  //pouzijeme obrazek se standardnim bannerem cz/en
    sLanguage:='en';
    if(GGForm_lSetLang.ItemIndex=0) then sLanguage:='cs';
    sUrl:='https://www.geocaching.cz/stator/img/banner_profil_'+sLanguage+'_256.png';
  end //odkaz s vlastnim obrazkem nebo s nahledem na statistiku, podle toho, co se tam posle
      //vzdy vsak png!!!
  else sUrl:='https://www.geocaching.cz/statistika/u/'+GGForm_eIdCz.Text+'/stator.png';
  //ukazovat budeme na statistiku na vlastnim FTP serveru nebo na gc.cz
  if(GGForm_lTarget.ItemIndex=1) then sHtml:=GGForm_eFtpBrowserUrl.Text
  else sHtml:='https://www.geocaching.cz/statistika/u/'+GGForm_eIdCz.Text+'/stator.html';
  //vytvorime odkaz a zapiseme ho do schranky
  sHtml:='<a href="'+sHtml+'"><img src="'+sUrl+'" /></a>';
  ClipboardWriteText(sHtml);
  //od prosince 2018 se pole na webove strance nejmenuje Bio, ale About
  ShowMessage(_('After profile settings page loads, select the About field, use CTRL+A, CTRL+V and Save these changes.'));  
  //otevreme URL v browseru, predpokladem je, ze uzivatel je prihlasen!!!!!!!!!!!!!
  if(not BrowseURL('https://www.geocaching.com/myaccount/settings/profile#Biography')) then
    ShowMessage(_('ERR: Browser defined in GeoGet doesn''t exist'));  
end;

procedure butSendOnClick(sender:TObject);
begin
  if((sender as TButton)=GGForm_butSendHtml) then SendHtml(true);
  if((sender as TButton)=GGForm_butSendLink) then SendLink('banner');
  if((sender as TButton)=GGForm_butSendLinkPreview) then SendLink('preview');
  //if((sender as TButton)=GGForm_butSendCss) then SendCss();
  if((sender as TButton)=GGForm_butSendImage) then SendImg(true);
end;

procedure SetFormLang(sLanguage:string); //nacte a nastavi jazyk formulare
begin
  UseLanguage(sLanguage);
  sLang:=sLanguage;                       //zmenime informaci o jazyku Stator
  RetranslateComponent(GGForm, GetCurrentTextDomain());
  //pokud je nacteny seznam modulu nacteme jej znovu
  if(GGForm_lModulesAll.Items.Count>0) then begin
    ReadModules();
  end;
  //nastaveni jazyka ostatnich formularu (ParForm) se deje asi az pri
  //jejich inicializaci a to uz je nastaven jazyk spravne. Neni tedy treba
  //jej nastavovat tady????
  //RetranslateComponent(ParForm, GetCurrentTextDomain());
end;

procedure lTargetOnChange(sender:TObject);
begin
  //GGForm_boxOwnFtp.Visible:=(GGForm_lTarget.ItemIndex=1);
    GGForm_eFtpUrl.Enabled:=(GGForm_lTarget.ItemIndex=1);
    GGForm_eFtpUser.Enabled:=(GGForm_lTarget.ItemIndex=1);
    GGForm_eFtpPwd.Enabled:=(GGForm_lTarget.ItemIndex=1);
    GGForm_butPwdUnlockFtp.Enabled:=(GGForm_lTarget.ItemIndex=1);
    GGForm_eFtpBrowserUrl.Enabled:=(GGForm_lTarget.ItemIndex=1);
  GGForm_boxUploadGcCz.Visible:=(GGForm_lTarget.ItemIndex={0} 111);
    //GGForm_bUloadPreviewImg.Enabled:=(GGForm_lTarget.ItemIndex={0} 111);
    //GGForm_ePreviewImgWidth.Enabled:=(GGForm_lTarget.ItemIndex={0} 111);
    //GGForm_ePreviewImgHeight.Enabled:=(GGForm_lTarget.ItemIndex={0} 111);
  GGForm_butSendHtml.Enabled:=(GGForm_lTarget.ItemIndex<>2);
  GGForm_butSendImage.Enabled:=(GGForm_lTarget.ItemIndex{<>2}=111);
  if(LowerCase(GEOGET_OWNER)='gordici') then begin
    GGForm_butSendImage.Enabled:=(GGForm_lTarget.ItemIndex=0);
    GGForm_butSendImage.Visible:=true;
  end;
  GGForm_butSendLink.Enabled:=(GGForm_lTarget.ItemIndex<>2);
  GGForm_butSendCss.Enabled:=(GGForm_lTarget.ItemIndex=111); //vzdy zakazane, zatim neni implementovane
  SetOnChange(nil);
end;

procedure ReadSettings; //nacita udaje z Config.ini pro zobrazeni na zalozce Settings
var ini:TMemIniFile;
    s,s1:string;
    i:integer;
    aList:TStringList;
    x,y:extended;
begin
  ini:=TMemIniFile.Create(GetProfileDir()+'Config.ini');
  try
    //napred musime nastavit jazyk formulare, protoze zmenou jazyka se
    //cely formular nastavi do stavu, v jakem je definovan v GFM souboru
    //a ne v jakem je aktualne
    //doplnime prvni polozku seznamu s vyberem jazyku o zkratku aktualniho jazyka
    s:=GGForm_lFormsLang.Items[0];
    s1:=Fetch(s,'-');
    if(s<>'') then GGForm_lFormsLang.Items[0]:=s; //nechame jen text bez zkratky
    s:=UpperCase(Copy(GetCurrentLanguage(),1,2));
    s1:=s+' - '+GGForm_lFormsLang.Items[0];
    GGForm_lFormsLang.Items[0]:=s1;
    //nacteme pozadovany jazyk
    s:=ini.ReadString('Main','FormsLanguage','');
//{$ifdef DEBUG_HELPER} LDH('CCCCC1 FormsLanguage="'+s+'"');{$endif}
    if(s='') then s:='by Geoget';
//{$ifdef DEBUG_HELPER} LDH('CCCCC2 s='+s);{$endif}
    i:=GGForm_lFormsLang.Items.IndexOf(s);
    if(i<0) then i:=0;
    GGForm_lFormsLang.ItemIndex:=i;
    //podle aktualni volby nastavime jazyk formulare
    s:=GGForm_lFormsLang.Items[i];
    s1:=LowerCase(Fetch(s,'-'));
    //zkusime najit zkratku mezi seznamem jazyku (protoze nevim, v jakem jazyku
    //je ted formular, nemohu porovnavat cely text)
    if(length(s1)=2) then begin
      SetFormLang(s1);
      //UseLanguage(s1);
      //sLang:=s1;                       //zmenime informaci o jazyku Stator
      //RetranslateComponent(GGForm, GetCurrentTextDomain());
      s1:=GGForm_lFormsLang.Items[0];
      GGForm_lFormsLang.Items[0]:=s1; //nastavime znovu polozku v seznamu jazyku
      GGForm_lFormsLang.ItemIndex:=i; //a vybereme spravnou polozku
    end;
    //ShowMessage('Nastavuji jazyk: '+s1);

    GGForm_eNickCom.Text:=gsUsername; //hodnoty jsou pouzity ze souboru config.pas
    GGForm_ePwdCom.Text:=gsPassword;
    GGForm_eNickCz.Text:=gcUsername;
    GGForm_ePwdCz.Text:=gcPassword;
    GGForm_eNickCom.Enabled:=false;
    GGForm_eNickCz.Enabled:=false;
    GGForm_ePwdCom.Enabled:=false;
    GGForm_ePwdCz.Enabled:=false;

    s:=UpperCase(ini.ReadString('Main','PREFIX','GC'));
    case s of
    'GC': GGForm_lSetPrefix.ItemIndex:=0;
    'WM': GGForm_lSetPrefix.ItemIndex:=1;
    'OC': GGForm_lSetPrefix.ItemIndex:=2;
    'GS': GGForm_lSetPrefix.ItemIndex:=3;
    else  GGForm_lSetPrefix.ItemIndex:=0;
    end;
    //volba databaze
    GeoDBNames(GGForm_cbDatabase.Items);
    //smazat zalozni databaze
    for i:=GGForm_cbDatabase.Items.Count-1 downto 0 do begin
      s:=GGForm_cbDatabase.Items[i];
      if(RegexFind('(?i)\.[0-9]{8}',s)) then GGForm_cbDatabase.Items.Delete(i);
    end;
    //vybereme uzivatelem nastavenou
    GGForm_cbDatabase.Items.Insert(0,'<Actual>');
    s:=ini.ReadString('Main','Database','<Actual>');
    i:=GGForm_cbDatabase.Items.IndexOf(s);
    if(i<0) then i:=0;
    GGForm_cbDatabase.ItemIndex:=i;

    s:=ini.ReadString('Main','HideParams','Yes');
    GGForm_bHideParams.Checked:=(UpperCase(s)='YES');
    s:=ini.ReadString('Main','ShowHtmlView','Yes');
    s:=ini.ReadString('Main','Mode','Beginner');
    i:=GGForm_lMode.Items.IndexOf(s);
    if(i<0) then i:=MODE_BEGINNER;
    GGForm_lMode.ItemIndex:=i;
    GGForm_eSetFileOut.Text:=ini.ReadString('Main','FileOut','');
    if(GGForm_eSetFileOut.Text='') then GGForm_eSetFileOut.Text:='Statistics.html';
    GGForm_eSetFileReplace.Text:=ini.ReadString('Main','FileReplace','');
    if(GGForm_eSetFileReplace.Text='') then GGForm_eSetFileReplace.Text:='Replace.ini';

    GGForm_eSetFileReplace.Text:=ini.ReadString('Main','FileReplace','');
    s:=ini.ReadString('Main','Css','No');
    GGForm_bMiscCss.Checked:=(UpperCase(s)='YES');
    s:=ini.ReadString('Main','IconToToolbar','Yes');
    GGForm_bMiscIconToToolbar.Checked:=(UpperCase(s)='YES');

    s:=ini.ReadString('Main','OutputLanguage','');
    if(s='') then s:='English';
    i:=GGForm_lSetLang.Items.IndexOf(s);
    if(i<0) then i:=0;
    GGForm_lSetLang.ItemIndex:=i;
    s:=ini.ReadString('Main','OutputCoding','');
    if(s='') then s:='UTF-8';
    i:=GGForm_lSetOutcoding.Items.IndexOf(s);
    if(i<0) then i:=0;
    GGForm_lSetOutcoding.ItemIndex:=i;
    GGForm_eSetWidth.Text:=ini.ReadString('Main','Width','750');

    s:=ini.ReadString('Main','FontSize','11px');
    i:=StrToInt(Fetch(s,'px'));
    GGForm_cSetFontSize.ItemIndex:=(i-11)/2;
    if(GGForm_cSetFontSize.ItemIndex<0) then GGForm_cSetFontSize.ItemIndex:=0;

    s:=ini.ReadString('Main','UnitDistance','');
    i:=GGForm_cSetUnits.Items.IndexOf(s);
    if(i<0) then i:=0;
    GGForm_cSetUnits.ItemIndex:=i;

    i:=ini.ReadInteger('Main','AlignColumnTitles',0);
    if(i<0) then i:=0;
    GGForm_cAlignTitles.ItemIndex:=i;

    s:=UpperCase(ini.ReadString('Main','OutputToClipboard','Yes'));
    GGForm_bClipboard.Checked:=(s<>'NO');
    GGForm_eIdCz.Enabled:=false;
    GGForm_eIdCz.Text:=ini.ReadString('Main','GcCzID','');
    if(GGForm_eIdcz.Text='') and (GGForm_eNickCz.Text<>'') then begin
      butGcCzIdOnClick(nil);
      //pokud ovsem tady neni nic nastaveno, mel by zustat priznak o neulozene
      //zmene, aby se pri ukonceni Statoru zmena ulozila. Nastvime tedy priznak
      //podle ktereho se pozdeji nastavi priznak neulozenych zmen
      //K tomu pouzijeme normalne zakazanou upravu ID hodnoty
      GGForm_eIdCz.Enabled:=(GGForm_eIdCz.Text<>'');
      //ShowMessage('$$$$ Nactene GC ID='+GGForm_eIdcz.Text);
    end;
		GGForm_butGuidCom.Visible:=false;		//udlk nen poteba u nelze nast GUID z API
    //GGForm_eGuidCom.Enabled:=true;		
    GGForm_eGuidCom.Text:=ini.ReadString('Main','GuidCom','');
    //if(GGForm_eGuidCom.Text='') and (GEOGET_Owner<>'') then begin
      //butGuidComOnClick(nil);
      //pokud ovsem tady neni nic nastaveno, mel by zustat priznak o neulozene
      //zmene, aby se pri ukonceni Statoru zmena ulozila. Nastvime tedy priznak
      //podle ktereho se pozdeji nastavi priznak neulozenych zmen
      //K tomu pouzijeme normalne zakazanou upravu ID hodnoty
      //GGForm_eGuidCom.Enabled:=(GGForm_eGuidCom.Text<>'');
      //ShowMessage('$$$$ Nactene GC ID='+GGForm_eIdcz.Text);
    //end;

    GGForm_eFtpUrl.Text:=ini.ReadString('Main','FtpUrl','');
    GGForm_eFtpUser.Text:=ini.ReadString('Main','FtpUser','');
    GGForm_eFtpPwd.Text:=ini.ReadString('Main','FtpPwd','');
    GGForm_eFtpBrowserUrl.Text:=ini.ReadString('Main','BrowserUrl','');
    GGForm_lTarget.ItemIndex:=ini.ReadInteger('Main','TargetForStat',2); //musi byt implicitne 2, aby generovani pracovalo shodne v pripade, ze polozka chybi
    s:=UpperCase(ini.ReadString('Main','UploadPreviewImg','No'));
    GGForm_bUploadPreviewImg.Checked:=(s<>'NO');
    GGForm_ePreviewImgWidth.Text:=ini.ReadString('Main','PreviewImgWidth','780');
    GGForm_ePreviewImgHeight.Text:=ini.ReadString('Main','PreviewImgHeight','1000');
    s:=UpperCase(ini.ReadString('Main','UpdateMapIniFile','Yes'));
    GGForm_bMapIniUpdate.Checked:=(s='YES');
    //skryjeme parametry pro FTP/nebo upload IMG, pokud box neni potreba
    //(u FTP je trochu problem s cilovym jmenem, ktere se pouziva i mimo FTP)
    lTargetOnChange(nil);

    GGForm_cSetSortFound.ItemIndex:=ini.ReadInteger('Main','SortFound',0);
    //domaci souradnice pro statistiku
    GetHomeCoord(x,y);
    GGForm_eSetHome.Text:=FormatCoordNum(x,y);
    //nicky na mych kesich
    GGForm_lMiscIdOwned.Items.Text:=ReplaceString(ini.ReadString('Main','OwnedId',''),'|',CRLF);
    ini.ReadSection('OwnedAuthors',GGForm_lMiscAuthor.Items);
    if(GGForm_lMiscAuthor.Items.Count=0) then begin
      GGForm_lMiscAuthor.Items.Add(GEOGET_OWNER);
      SetOwnedAuthors(GGForm_lMiscAuthor.Items as TStringList);
    end;
    i:=ini.ReadInteger('Main','SaveTempTable',0);
    GGForm_bMiscSaveTempTable.Checked:=(i=1);
    //ignorovane kese
    ini.ReadSectionValues('IgnoreCaches',GGForm_lMiscIgnore.Items);
  finally
    ini.Free();
  end;
  if(aList<>nil) then aList.Free();
  SetOwnedIds('');
end;

procedure SaveSettings;
var ini:TMemIniFile;
    s:string;
    i:integer;
begin
  ini:=TMemIniFile.Create(GetProfileDir()+'Config.ini');
  try
    case GGForm_lSetPrefix.ItemIndex of
    1: ini.WriteString('Main','Prefix','WM');
    2: ini.WriteString('Main','Prefix','OC');
    3: ini.WriteString('Main','Prefix','GS');
    else ini.WriteString('Main','Prefix','GC');
    end;
    s:=GGForm_cbDatabase.Items[GGForm_cbDatabase.ItemIndex];
    ini.WriteString('Main','Database',s);
    if(GGForm_bHideParams.Checked) then ini.WriteString('Main','HideParams','Yes')
    else ini.WriteString('Main','HideParams','No');
    s:=GGForm_eSetFileOut.Text;
    if(s='') then s:='Statistics.html';
    ini.WriteString('Main','FileOut',s);
    s:=GGForm_eSetFileReplace.Text;
    if(s='') then s:='Replace.ini';
    s:=RegexReplace('.*\\',s,'',false);
    ini.WriteString('Main','FileReplace',s);
    if(GGForm_bMiscCss.Checked) then ini.WriteString('Main','Css','Yes')
    else ini.WriteString('Main','Css','No');
    if(GGForm_bMiscIconToToolbar.Checked) then ini.WriteString('Main','IconToToolbar','Yes')
    else ini.WriteString('Main','IconToToolbar','No');
    ini.WriteString('Main','FormsLanguage',GGForm_lFormsLang.Items[GGForm_lFormsLang.ItemIndex]);
    ini.WriteString('Main','OutputLanguage',GGForm_lSetLang.Items[GGForm_lSetLang.ItemIndex]);
    ini.WriteString('Main','OutputCoding',GGForm_lSetOutcoding.Items[GGForm_lSetOutcoding.ItemIndex]);
    ini.WriteString('Main','Width',GGForm_eSetWidth.Text);
    ini.WriteString('Main','GcCzID',GGForm_eIdcz.Text);
		if(isGuid(GGForm_eGuidCom.Text) or (Trim(GGForm_eGuidCom.Text)='')) then begin
			ini.WriteString('Main','GuidCom',GGForm_eGuidCom.Text);
			ini.WriteString('Main','RefCodeCom',GGForm_eGuidCom.Text);
    end else begin
      ShowMessage(_('ERR: Wrong user GUID from geocaching.com')+CRLF   
        +_('Value won''t be saved'));  
		end;
    ini.WriteString('Main','FtpUrl',GGForm_eFtpUrl.Text);
    ini.WriteString('Main','FtpUser',GGForm_eFtpUser.Text);
    ini.WriteString('Main','FtpPwd',GGForm_eFtpPwd.Text);
    ini.WriteString('Main','BrowserUrl',GGForm_eFtpBrowserUrl.Text);
    ini.WriteInteger('Main','TargetForStat',GGForm_lTarget.ItemIndex);
    if(GGForm_bUploadPreviewImg.Checked) then ini.WriteString('Main','UploadPreviewImg','Yes')
    else ini.WriteString('Main','UploadPreviewImg','No');
    ini.WriteString('Main','PreviewImgWidth',GGForm_ePreviewImgWidth.Text);
    ini.WriteString('Main','PreviewImgHeight',GGForm_ePreviewImgHeight.Text);
    if(GGForm_bMapIniUpdate.Checked) then ini.WriteString('Main','UpdateMapIniFile','Yes')
    else ini.WriteString('Main','UpdateMapIniFile','No');
    ini.WriteString('Main','HomeCoord',GGForm_eSetHome.Text);
    ini.WriteInteger('Main','SortFound',GGForm_cSetSortFound.ItemIndex);
    ini.WriteString('Main','UnitDistance',GGForm_cSetUnits.Items[GGForm_cSetUnits.ItemIndex]);
    ini.WriteString('Main','OwnedId',ReplaceString(Trim(GGForm_lMiscIdOwned.Items.Text),CRLF,'|'));
    ini.WriteInteger('Main','AlignColumnTitles',GGForm_cAlignTitles.ItemIndex);
    ini.WriteString('Main','FontSize',IntToStr((GGForm_cSetFontSize.ItemIndex*2)+11)+'px');
    ini.WriteInteger('Main','SaveTempTable',(GGForm_bMiscSaveTempTable.Checked as integer));

    if(GGForm_bClipboard.Checked) then ini.WriteString('Main','OutputToClipboard','Yes')
    else ini.WriteString('Main','OutputToClipboard','No');
    //seznam ignorovanych kesi
    ini.EraseSection('IgnoreCaches');  //napred vymazat vsechny, ktere tam byly
    //pridat uzivatelem nastavene
    for i:=0 to GGForm_lMiscIgnore.Items.Count-1 do begin
      s:=GGForm_lMiscIgnore.Items[i];
      ini.WriteString('IgnoreCaches',SeparateLeft(s,'='),SeparateRight(s,'='));
    end;
    //popereme se s autory
    ini.EraseSection('OwnedAuthors');
    for i:=0 to GGForm_lMiscAuthor.Items.Count-1 do begin
      ini.WriteString('OwnedAuthors',GGForm_lMiscAuthor.Items[i],'');
    end;
  finally
    ini.UpdateFile();
    ini.Free();
  end;
end;

procedure butSetFileEdit(sender:TObject);
var s,sCaption,sOption,sDir,sFilter:string;
begin
  case sender of
  GGForm_butFileOut:     begin
                           s:=GGForm_eSetFileOut.Text;
                           sCaption:=_('Select output file');
                           sOption:='ofHideReadOnly';
                           sDir:=GetProfileDir();
                           sFilter:=_('HTML files')+' (*.html)|*.html'
                                   +'|'+_('all files')+' (*.*)|*.*';
                         end;
  {
  GGForm_butSetReplace:  begin  //tohle zatim neni povolene, protoze zakaz zmeny
                                //adresare nefunguje
                           s:=GGForm_eSetFileReplace.Text;
                           sCaption:=_('Select INI file');
                           sOption:='ofFileMustExist,ofHideReadOnly,ofNoChangeDir';
                           sDir:=GetProfileDir();
                           sFilter:= _('INI files')+' (*.ini)|*.ini';
                         end;
  }
  else exit;
  end;
  if(OpenDlg(sCaption,sDir,sOption,sFilter,s)) then begin
    //adresar profilu vyhodime, ostatni nechame s absolutni cestou
    s:=ReplaceString(s,GetProfileDir(),'');
    case sender of
    GGForm_butFileOut:          GGForm_eSetFileOut.Text:=s;
    GGForm_butSetReplace:       GGForm_eSetFileReplace.Text:=s;
    else exit;
    end;
    SetOnChange(nil);
  end;
end;

procedure butSetHomeEditOnClick(sender:TObject);
var s:string;
    x,y:extended;
begin
  s:=GGForm_eSetHome.Text;
  if ParseWgsStr(s,x,y) then
  if(CoordEdit(_('Homecoordinates for statistics'),'', x, y)) then
    GGForm_eSetHome.Text:=FormatCoordNum(x,y);
end;

procedure butMiscItemAddOnClick(sender:TObject);
var i:integer;
    lb:TListBox;
    s,sCap,sPrompt:string;
begin
  case (sender) of
  GGForm_butMiscIdOwnedAdd: begin
                             lb:=(GGForm_lMiscIdOwned);
                             sCap:=_('New cache''s ID');
                             sPrompt:=_('Enter GC code for new owned cache');
                           end;
  GGForm_butMiscAuthorAdd: begin
                             lb:=(GGForm_lMiscAuthor);
                             sCap:=_('New author');
                             sPrompt:=_('Write author''s nick');
                           end;
  GGForm_butMiscIgnoreAdd: begin
                             lb:=(GGForm_lMiscIgnore);
                             sCap:=_('New cache to ignore');
                             sPrompt:=_('Write GC code for ignored cache. Format:')+CRLF+'   GCcode=any_text';
                           end;
  else exit;
  end;
  s:=InputBox(sCap, sPrompt, '');
  if(s<>'') then begin
    i:=lb.Items.Add(s);
    lb.ItemIndex:=i;
    SetOnChange(nil);
    if(sender=GGForm_butMiscAuthorAdd) then SetOwnedAuthors(lb.Items as TStringList);
  end;
end;

procedure butMiscItemDelOnClick(sender:TObject);
var i:integer;
    lb:TListBox;
begin
  case (sender) of
  GGForm_butMiscIdOwnedDel: lb:=(GGForm_lMiscIdOwned);
  GGForm_butMiscAuthorDel: lb:=(GGForm_lMiscAuthor);
  GGForm_butMiscIgnoreDel: lb:=(GGForm_lMiscIgnore);
  else exit;
  end;
  i:=lb.ItemIndex;
  if(i>-1) then begin
    lb.Items.Delete(i);
    if(i>lb.Items.Count-1) then i:=lb.Items.Count-1;
    lb.ItemIndex:=i;
    SetOnChange(nil);
    if(sender=GGForm_butMiscAuthorDel) then SetOwnedAuthors(lb.Items as TStringList);
  end;
end;

procedure butMiscIdOwnedAddOnClick(sender:TObject);
begin
  butMiscItemAddOnClick(sender);
  SetOwnedIds('');
end;

procedure butMiscIdOwnedDelOnClick(sender:TObject);
begin
  butMiscItemDelOnClick(sender);
  SetOwnedIds('');
end;

procedure butMiscAuthorAddOnClick(sender:TObject);
begin
  butMiscItemAddOnClick(sender);
  SetOwnedIds('');
end;

procedure butMiscAuthorDelOnClick(sender:TObject);
begin
  butMiscItemDelOnClick(sender);
  SetOwnedIds('');
end;

procedure butMiscShowIconsOnClick(sender:TObject);
var sHtml:string;
    i:integer;
begin  //vytvori HTML soubor s odkazy na ikony a zobrazi jej
  sHtml:='<html><body>'+CRLF;
  for i:=StrToInt(GGForm_eMiscShowIconsMin.Text) to StrToInt(GGForm_eMiscShowIconsMax.Text) do begin
    if(GGForm_rMiscShowIcons.ItemIndex=0) or (GGForm_rMiscShowIcons.ItemIndex=2) then
      sHtml:=sHtml+'<img src="https://www.geocaching.com/images/wpttypes/'+IntToStr(i)+'.gif"'
        +' title="'+IntToStr(i)+'" /> '+CRLF;
    if(GGForm_rMiscShowIcons.ItemIndex=1) or (GGForm_rMiscShowIcons.ItemIndex=2) then
      sHtml:=sHtml+'<img src="https://www.geocaching.com/images/wpttypes/sm/'+IntToStr(i)+'.gif"'
        +' title="'+IntToStr(i)+' (small)" /> '+CRLF;
  end;
  sHtml:=sHtml+'</body></html>'+CRLF;
  StringToFile(sHtml,GetMyDir()+'Tmp\TmpIcons.html');
  RunShell(GetMyDir()+'Tmp\TmpIcons.html');
end;

procedure lFormsLangOnChange(sender:TObject);
var i:integer;
    s,s1:string;
begin
  i:=GGForm_lFormsLang.ItemIndex;
  if(i<0) then exit;
  s:=GGForm_lFormsLang.Items[i];
  s1:=Fetch(s,'-');
  if(length(s1)=2) then begin
    ShowMessage(_('Changes will take effect after saving and restarting Stator'));
    //SetFormLang(LowerCase(s1));
    //GGForm_lFormsLang.ItemIndex:=i;
  end;
  SetOnChange(nil);
end;

procedure sVersionInfoOnClick(sender:TObject);
var s:string;
begin
  s:=GEOGET_SCRIPTDIR+'\Stator\VersionInfo_'
    +UpperCase(copy(GetCurrentLanguage(),1,2))+'.html';
  if(not FileExists(s)) then s:=GEOGET_SCRIPTDIR+'\Stator\VersionInfo_EN.html';
  s:=FileToString(s);
  ShowHTMLMessageSize('Stator Installation Info',s,700,500);
end;

function MapFilesUpdate_ZrusenoXXXXXX:string;
var s,sFile,sVerServer,sVerLocal,str,sMapServer,sVerLocalCompare,sVerServerCompare:string;
    eVerServer,eVerLocal:extended;
begin
  sMapServer:=CONST_MAPGEN_SVG_URL_GCCZ;
  //sMapServer:=CONST_MAPGEN_SVG_URL_DEBUG;
  Result:='Mapovy server: '+sMapServer+'<br><br>'
    +'<table border=1 style="margin-top:5px; border:red 0px solid; background-color:white; color:black; font-size: 13px; border-collapse: collapse;"><tr><th>File</th><th>PC</th><th>Server</th></tr>'+CRLF;

  //zkontolujeme verzi Statoru proti verzi na serveru
  //pokud je Stator starsi nez na serveru, hlasi chybu a neumozni aktualizaci souboru
  GeoBusyCaption(_('Checking Stator version'));  
  if(HttpAsk('GET',sMapServer+'files.php?fce=GetFile&file=StatorVersion.ini','','',str)=false) then str:='';
  if(str='') then begin
    ShowMessage(_('ERR: Failed while checking Stator version')); 
    Result:=Result+'<td>StatorVersion.ini</td><td>&nbsp;</td><td style="color:red;">ERROR</td>';
    exit;
  end;
  Fetch(str,'version=');
  sVerServer:=Fetch(str,CRLF);   //tady
  //kvuli prechodum radu ve verzich (9 na 10) neni mozne kontrolovat jako string
  eVerServer:=StrToFloat(ReplaceString(sVerServer,'.',''));
  str:=FileToString(GetMyDir()+'Stator.meta.ini');
  Fetch(str,'version=');
  sVerLocal:=Fetch(str,CRLF);
  eVerLocal:=StrToFloat(ReplaceString(sVerLocal,'.',''));
  if(eVerLocal<eVerServer) then begin
    ShowMessage(_('ERR: this version is too old, can''t update from server.')
      +CRLF+CRLF+_('Update Stator!'));  
    Result:=Result+'<td>Stator.meta.ini</td><td>'+sVerLocal+'</td><td style="color:red;">'+sVerServer+' (ERROR)</td></tr></table>';
    exit;
  end;

  GeoBusyCaption(_('Updating files for coloured maps')); 
  //nacteme seznam souboru a jejich verzi ze serveru
  if(HttpAsk('GET',sMapServer+'files.php?fce=GetVer','','',s)=false) then begin
    ShowMessage(_('ERR: error while checking version file')); 
    Result:=Result+'<td style="color:red;">'+sVerServer+' (ERROR)</td>';
    exit;
  end;
  s:=Trim(s);
  {$ifdef DEBUG_HELPER} LDH('Seznam souboru ze serveru:'+CRLF+s);{$endif}
  while(s<>'') do begin //zpracujeme vsechny soubory
    sVerServer:=Trim(Fetch(s,Chr(10))); //gc.cz vraci oddelovac jen LF, u8 vraci CRLF
    sFile:=Fetch(sVerServer,'=');
    if(not FileExists(GetModulesDir()+sFile)) then str:=''
    else str:=FileToString(GetModulesDir()+sFile);
    Result:=Result+'<tr><td>'+sFile+'</td>';
    if(Pos('From',sFile)>0) then begin
      Result:=Result+'<td colspan=2>Nepouzivany soubor, ignoruji</td></tr>'+CRLF;
      continue;
    end;
    //{$ifdef DEBUG_HELPER} LDH(str);{$endif}
    Fetch(str,'version=');
    sVerLocal:=Fetch(str,CRLF);
    //vyhazeme oddelovace
    sVerLocalCompare:=ReplaceString(sVerLocal,'.','');
    sVerServerCompare:=ReplaceString(sVerServer,'.','');
    {$ifdef DEBUG_HELPER} LDH('Soubor: '+sFile+' - verze lokalni: '+sVerLocal+', serverova: '+sVerServer);{$endif}
    Result:=Result+'<td>'+sVerLocal+'</td>';
    //kvuli prechodum radu ve verzich (9 na 10) neni mozne kontrolovat jako string
    eVerLocal:=StrToFloat(sVerLocalCompare);
    eVerServer:=StrToFloat(sVerServerCompare);
    if(eVerLocal<eVerServer) then begin
      {$ifdef DEBUG_HELPER} LDH('Aktualizuji soubor: '+sFile);{$endif}
      if(HttpAsk('GET',sMapServer+'files.php?fce=GetFile&file='+sFile,'','',str)=false) then begin
        ShowMessage(_('ERR: file updating failed')+': '+sFile); 
        Result:=Result+'<td style="color:red;">'+sVerServer+' (ERROR)</td>';
      end
      else begin
        Result:=Result+'<td style="color:blue;>'+sVerServer+' '+_('(updated)')+'</td>' 
        StringToFile(str,GetModulesDir()+sFile);
      end;
    end;
    if(sVerLocalCompare=sVerServerCompare) then begin
      Result:=Result+'<td>'+sVerServer+'</td>'
    end;
    if(sVerLocalCompare>sVerServerCompare) then begin
      Result:=Result+'<td>'+sVerServer+' '+_('(old)')+'</td>';  
    end;
    Result:=Result+'</tr>'+CRLF;
  end;
  Result:=Result+'</table>'+CRLF;

  //vytvorime soubor pro kontrolu posledni aktualizace
  ForceDirectories(GetTmpDir());
  StringToFile('--- File used to autocheck version of map generator files.'+CRLF+CRLF
    +'It''s used to remember when files have been checked.',
    GetTmpDir()+'MapFilesUpdate.txt');
end;

procedure CheckMapFilesUpdate;
var sFile:string;
b:boolean;
begin
  //zkontrolujeme, kdy naposledy byly soubory kontrolovany a pokud je to
  //dost davno, zkontrolujeme to
  b:=false; //nekontrolovat
  sFile:=GetMyDir()+'Tmp\MapFilesUpdate.txt';
  if(not FileExists(sFile)) then b:=true
  else begin
    if(now()-GetFileTime(sFile)>6) then b:=true; //tyden stare uz aktualizujeme
  end;
  if(not GGForm_bMapIniUpdate.Checked) then b:=false;
  if(b) then MapFilesUpdate();  //vraceny string s vysledkem nezobrazujeme
end;

procedure butMapUpdateOnClick(sender:TObject);
begin
  ShowHTMLMessageSize(_('Map files update result:'),
    MapFilesUpdate(),650,300); //zobrazime vysledek aktualizace
end;

procedure InitSettings;
begin
{$ifdef PROFILER}ProfileStart('InitSettings');{$endif}     //OK
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitSettings(), start');
{$endif}
  GeoBusyKind(_('Loading settings')); 
  ReadSettings();
  GGForm_eSetFileOut.OnChange:=@SetOnChange;
  GGForm_butFileOut.OnClick:=@butSetFileEdit;
  GGForm_cbDatabase.OnChange:=@SetOnChange;
  GGForm_lProfiles.OnChange:=@SetOnChange;
  GGForm_lSetPrefix.OnChange:=@SetOnChange;
  GGForm_lFormsLang.OnChange:=@lFormsLangOnChange;
  GGForm_lSetLang.OnChange:=@SetOnChange;
  GGForm_lSetOutcoding.OnChange:=@SetOnChange;
  GGForm_butGcCzId.OnClick:=@butGcCzIdOnClick;
  GGForm_butGuidCom.OnClick:=@butGuidComOnClick;
  GGForm_butSetHomeEdit.OnClick:=@butSetHomeEditOnClick;
  GGForm_butSendHtml.OnClick:=@butSendOnClick;
  GGForm_butSendLink.OnClick:=@butSendOnClick;
  GGForm_butSendImage.OnClick:=@butSendOnClick;
  GGForm_butSendCss.OnClick:=@butSendOnClick;
  GGForm_lTarget.OnChange:=@lTargetOnChange;
  GGForm_eFtpUrl.OnChange:=@SetOnChange;
  GGForm_eFtpUser.OnChange:=@SetOnChange;
  GGForm_eFtpPwd.OnChange:=@SetOnChange;
  GGForm_eFtpBrowserUrl.OnChange:=@SetOnChange;
	GGForm_eGuidCom.OnChange:=@SetOnChange;	//Zmna GUID
  //GGForm_butLink.OnClick:=@butLinkOnClick;

  GGForm_eSetHome.OnChange:=@SetOnChange;
  GGForm_cSetSortFound.OnChange:=@SetOnChange;
  GGForm_cSetUnits.OnChange:=@SetOnChange;
  GGForm_cAlignTitles.OnChange:=@SetOnChange;
  GGForm_cSetFontSize.OnChange:=@SetOnChange;
  GGForm_bMiscIconToToolbar.OnClick:=@SetOnChange;
  GGForm_bMiscCss.OnClick:=@SetOnChange;
  GGForm_bClipboard.OnClick:=@SetOnChange;
  GGForm_bUploadPreviewImg.OnClick:=@SetOnChange;
  GGForm_bMapIniUpdate.OnClick:=@SetOnChange;
  GGForm_ePreviewImgWidth.OnClick:=@SetOnChange;
  GGForm_ePreviewImgHeight.OnClick:=@SetOnChange;
  GGForm_eSetFileReplace.OnChange:=@SetOnChange;
  GGForm_eSetWidth.OnChange:=@SetOnChange;
  GGForm_butMiscShowIcons.OnClick:=@butMiscShowIconsOnClick;

  GGForm_butMiscIdOwnedAdd.OnClick:=@butMiscIdOwnedAddOnClick;
  GGForm_butMiscIdOwnedDel.OnClick:=@butMiscIdOwnedDelOnClick;
  GGForm_butMiscAuthorAdd.OnClick:=@butMiscAuthorAddOnClick;
  GGForm_butMiscAuthorDel.OnClick:=@butMiscAuthorDelOnClick;
  GGForm_butMiscIgnoreAdd.OnClick:=@butMiscItemAddOnClick;
  GGForm_butMiscIgnoreDel.OnClick:=@butMiscItemDelOnClick;
  GGForm_butMapUpdate.OnClick:=@butMapUpdateOnClick;

{
  GGForm_butPwdUnlockCom.OnClick:=@butPwdUnlock;
  GGForm_butPwdUnlockCz.OnClick:=@butPwdUnlock;
  GGForm_butPwdUnlockFtp.OnClick:=@butPwdUnlock;
}
  GGForm_butPwdUnlockCom.Visible:=false;
  GGForm_butPwdUnlockCz.Visible:=false;
  GGForm_butPwdUnlockFtp.Visible:=false;

  GGForm_butSendCss.Visible:=false;
  GGForm_sPreviewImgWarn.Visible:=(GetChromePath()='');

  GGForm_sVersionInfo.OnClick:=@sVersionInfoOnClick;

  GGForm_boxUploadGcCz.top:=GGForm_boxOwnFtp.top;
  GGForm_boxUploadGcCz.left:=GGForm_boxOwnFtp.left;
  GGForm_boxUploadGcCz.width:=GGForm_boxOwnFtp.width;

  CheckMapFilesUpdate(); //zkontrolujeme aktualnost datovych souboru pro SVG mapy

{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitSettings(), stop');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;