//modul poskytuje vypocetni funkce, sam o sobe nic nevytvari
//funkce s *_INI_* zjistuje hodnoty z INI souboru, neni pro ne tedy potreba
//upravovat odpovidajici hodnoty ve funkcich v tomto *.pas souboru

function CalcRegionTagSupport_TagForMap(sMap:string; bShowError:boolean; var sCategory,sValue,sCategoryNad,sValueNad:string):boolean;
//vraci priznak nalezeni
var s:string;
    ini:TMemIniFile;
begin
  Result:=false; //nenasli jsme mapu
  sCategory:='';
  sValue:='';
  sCategoryNad:='';
  sValueNad:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Maps.ini');
  try
    s:=ini.ReadString('Map-tags',sMap,'?');
    {$ifdef DEBUG_HELPER} LDH('Read *.ini: sMap='+sMap+', s='+s); {$endif}
    if(s<>'?') then begin    //pokud najdeme, pouzijeme
      sCategory:=Fetch(s,';');
      sValue:=Fetch(s,';');
      sCategoryNad:=Fetch(s,';');
      sValueNad:=s;
      Result:=true;
    end
    else begin
      if(bShowError) then AddError(_('WARN: Couldn''t get TAG category for map:')+' '+sMap)
      else Log(_('WARN: Couldn''t get TAG category for map:')+' '+sMap);
    end;
  finally
    ini.Free();
  end;
end;

function CalcRegionTagSupport_GetMapName(sCountry:string):string;
//zjisti jmeno mapy, kterou je treba nakreslit pro zvoleny stat/okres/mesto
var ini:TMemIniFile;
    s:string;
begin
  //nacteme seznam map statu s delenim do kraju
  Result:='';
  ini:=TMemIniFile.Create(GetModulesDir()+'MapGenSvg.Maps.ini');
  try
    s:=ini.ReadString('Kraje',sCountry,'');
    if(s='') then s:=ini.ReadString('Okresy',sCountry,'');
    if(s='') then s:=ini.ReadString('Mesta',sCountry,'');
    Result:=Fetch(s,'(');
  finally
    ini.Free();
  end;
end;

function CalcRegionTagSupport_TagForCountry(sCountry:string; bShowError:boolean; var sCategory:string):boolean;
//vraci priznak nalezeni
var s,sValue,sCategoryNad,sValueNad:string;
begin
  Result:=false;
  sCategory:='';
  //najdeme pro stat mapu a pro mapu tag
  s:=CalcRegionTagSupport_GetMapName(sCountry);
  if(s<>'') then begin
    CalcRegionTagSupport_TagForMap(s, bShowError,sCategory,sValue,sCategoryNad,sValueNad);
  end;
  if(sCategory='') then begin
    if(bShowError) then AddError(_('WARN: Couldn''t get TAG category for country:')+' '+sCountry)
    else Log(_('WARN: Couldn''t get TAG category for country:')+' '+sCountry);
  end;
end;

//hlavni funkce nedela nic
function CalcRegionTagSupport_Run(aPar:TStringList):string;
begin
  Result:='';
end;

procedure CalcRegionTagSupport_Free;
begin
end;